unit OggDdsdLib;

interface

uses
  SysUtils, Classes, ddsd7, OggDataLib, Windows;

//{$DEFINE USE_3D}

var
  _OggToWaveFadeInTime:Integer=128;

//Oggt@CDDSDWaveDataɕϊ
function OggToWaveData(DS:TDDSD7;Filename:String):TDDSDWaveData; overload;
function OggToWaveData(DS:TDDSD7;ss:TMemoryStream):TDDSDWaveData; overload;
{$IFDEF USE_3D}
function OggToWave3D(DS:TDDSD7;Filename:String):TDDSDWave3D; overload;
function OggToWave3D(DS:TDDSD7;ss:TMemoryStream):TDDSDWave3D; overload;
{$ENDIF}

implementation

//------------------------------------------------------------------------------
// Oggf[^DDSDWaveDataɕϊ
function OggToWaveData(DS:TDDSD7;Filename:String):TDDSDWaveData; overload;
var
  ss : TmemoryStream;
begin
  result := nil;
  if (FileExists(Filename)=FALSE)then exit;
  // Xg[쐬
  ss := TMemoryStream.Create;
  ss.LoadFromFile(Filename);
  // Xg[ǂݍ݂ɓn
  result := OggToWaveData(DS,ss);
end;

function OggToWaveData(DS:TDDSD7;ss:TMemoryStream):TDDSDWaveData; overload;
var
  Dest    : TDDSDWaveData;
  Buf     : TMemoryStream;
begin
  RESULT := NIL;
  //O
  if (ss = nil)then exit;
  //
  Buf := OggToMemoryStream(ss);
  // TDDSDWaveDataɏ
  Dest := TDDSDWaveData.CreateBuffer(DS,44100,16,TRUE,Buf.Size);
  Dest.BlockCopy(0,Buf.Memory,Buf.Size);
  // 
  Buf.Free;
  //ԂlԂ
  result := Dest;
end;

{$IFDEF USE_3D}
//------------------------------------------------------------------------------
// Oggf[^DDSDWaveDataɕϊ
function OggToWave3D(DS:TDDSD7;Filename:String):TDDSDWave3D; overload;
var
  ss : TmemoryStream;
begin
  result := nil;
  if (FileExists(Filename)=FALSE)then exit;
  // Xg[쐬
  ss := TMemoryStream.Create;
  ss.LoadFromFile(Filename);
  // Xg[ǂݍ݂ɓn
  result := OggToWave3D(DS,ss);
end;

function OggToWave3D(DS:TDDSD7;ss:TMemoryStream):TDDSDWave3D; overload;
var
  Dest    : TDDSDWave3D;
  Buf     : TMemoryStream;
begin
  RESULT := nil;
  if (ss = nil)then exit;
  //
  Buf := OggToMemoryStream(ss);
  // TDDSDWaveDataɏ
  Dest := TDDSDWave3D.CreateBuffer(DS,44100,16,TRUE,Buf.Size);
  Dest.BlockCopy(0,Buf.Memory,Buf.Size);
  // 
  Buf.Free;
  //ԂlԂ
  result := Dest;
end;
{$ENDIF}

end.
