unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,OggDataLib, OggPlayerLib, OggWuvorbisLib, StdCtrls, ddsd, ComCtrls, ExtCtrls,
  mmsystem, DGCarad9, ShellAPI;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Button3: TButton;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    ProgressBar1: TProgressBar;
    ProgressBar2: TProgressBar;
    ScrollBar1: TScrollBar;
    Label1: TLabel;
    Label2: TLabel;
    Button2: TButton;
    Button5: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    ScrollBar2: TScrollBar;
    Label6: TLabel;
    Label7: TLabel;
    ScrollBar3: TScrollBar;
    ScrollBar4: TScrollBar;
    Label9: TLabel;
    ScrollBar5: TScrollBar;
    Button11: TButton;
    Button12: TButton;
    Image1: TImage;
    Button13: TButton;
    Button14: TButton;
    Image2: TImage;
    Image3: TImage;
    Label11: TLabel;
    Label12: TLabel;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    Button18: TButton;
    Button19: TButton;
    Button20: TButton;
    Button21: TButton;
    Button22: TButton;
    Button23: TButton;
    Button24: TButton;
    Button25: TButton;
    Button26: TButton;
    Button27: TButton;
    Button28: TButton;
    Label8: TLabel;
    Label10: TLabel;
    Label13: TLabel;
    Button29: TButton;
    Button30: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    DDSD1: TDDSD;
    ScrollBar6: TScrollBar;
    Label14: TLabel;
    ScrollBar7: TScrollBar;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    MinVolumeBar: TScrollBar;
    FadeVolumeBar: TScrollBar;
    Image4: TImage;
    Label19: TLabel;
    MaxVolumeBar: TScrollBar;
    ListenerLabel: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure ScrollBar3Change(Sender: TObject);
    procedure ScrollBar4Change(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure ScrollBar5Change(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);
    procedure Button19Click(Sender: TObject);
    procedure Button20Click(Sender: TObject);
    procedure Button18Click(Sender: TObject);
    procedure Button21Click(Sender: TObject);
    procedure Button22Click(Sender: TObject);
    procedure Button26Click(Sender: TObject);
    procedure Button25Click(Sender: TObject);
    procedure Button23Click(Sender: TObject);
    procedure Button24Click(Sender: TObject);
    procedure Button27Click(Sender: TObject);
    procedure Button28Click(Sender: TObject);
    procedure Button29Click(Sender: TObject);
    procedure Button30Click(Sender: TObject);
    procedure ScrollBar6Change(Sender: TObject);
    procedure ScrollBar7Change(Sender: TObject);
    procedure MaxVolumeBarChange(Sender: TObject);
  private
    { Private 錾 }
    FScrollBarLock : Boolean;
    FOnIdleLock   : Boolean;
    procedure DropFiles(var Msg:TWMDROPFILES); message WM_DROPFILES;
    procedure Load(no:Integer; filename:String);
    procedure WavePosFunction(var pos:Integer; var len:Integer);
  public
    { Public 錾 }
    OggPlayer : TOggPlayer;
    OggData : array[0..1] of TOggData;

    graph1,graph2,graph3 : array[0..255] of Single;

    wav:TDDSDWaveData;
    procedure UpdateWav(Sender:TDDSDGenWave; Player:TDDSDChannel; ofs,len:Cardinal);
    procedure IdleEvent(sender:TObject; var done:Boolean);
end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  Len : Integer;
begin
  chdir(ExtractFilePath(Application.ExeName));
  //DLLǂݍŁAOgggp\ɂB
  _VorbisfileInitialize('wuvorbis.dll');

  // obt@
  Len := 1024*64;

  // Xg[~OĐ
  // ڂDDDDwvQƂ̂
  // K 44100Hz 16Bit STEREO łȂƃ_[II
  wav:=TDDSDWaveData.CreateStream(DDSD1, 44100, 16, TRUE, Len);
  wav.OnUpdate:=UpdateWav;

  // Oggf[^ĐPlayerClass
  // gčĐ邱
  // iOggf[^łĐł邯ǂˁj
  OggPlayer := TOggPlayer.Create(Len);
  OggPlayer.WavePositionEvent := WavePosFunction;   //萫iɌ݃^Cmꍇ

  // OggDataClassB
  // Đt@Cɓǂݍ܂āAOggPlayerɓo^Ă
  OggData[0]  := TOggData.Create(Len);
  OggData[1]  := TOggData.Create(Len);

  //ĐJn
  DDSD1[0].WaveData:=wav;
  DDSD1[0].LoopPlay;

  MaxVolumeBarChange(sender);
  
  Application.OnIdle := IdleEvent;
  DragAcceptFiles(Handle, True);
  TimeBeginPeriod(1);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Application.OnIdle := nil;
  
  // Xg[~OTEh̉
  DDSD1[0].Stop;
  DDSD1[0].WaveData := nil;
  if (Wav <> nil)then Wav.Free;

  // Ogg֘A
  OggPlayer.UnLoad(0);
  OggPlayer.UnLoad(1);

  OggData[0].Free;
  OggData[1].Free;
  OggPlayer.Free;

  // DLL̉
  _VorbisfileFinalize;

  //D&D
  DragAcceptFiles(Handle, FALSE);

  TimeEndPeriod(1);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  // Oggt@CI
  if (Opendialog1.Execute = FALSE)then exit;
  Load(0,Opendialog1.FileName);
end;

procedure TForm1.UpdateWav(Sender: TDDSDGenWave; Player: TDDSDChannel; ofs,
  len: Cardinal);
  function inWritePositionCheck:Boolean;
  var
    p,w : Cardinal;
  begin
    //݈ʒu`FbN
    //PlayPos`WritePos̊Ԃ͏݋֎~̈
    RESULT := FALSE;
    if (Sender.Buffer=nil)then exit;
    Sender.Buffer.GetCurrentPosition(@p,@w);

    if (p>w)then exit;
    if (p>ofs)and(p<ofs+len)then exit;
    if (w>ofs)and(w<ofs+len)then exit;

    RESULT := TRUE;
  end;
begin
  //OggPlayerɃ_O߂𔭌
  //ƁAقǓo^OggDataSĂ𓝍ďo͂
  OggPlayer.Rendering;
  //Ƃ́AXg[~OTEhɃ_Oʂ]
  //RenderingŎԌo߂Ă̂ŁA߂邩Ă
  if (inWritePositionCheck)then wav.BlockCopy(ofs,OggPlayer.Offset,len);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  // Tbɉ1.0ɐݒitF[hCłȁj
  OggPlayer.SetVolume(0, 1.0, 5.0);
  // Đ߂𔭌ĂƃCC
  OggPlayer.Play(0,TRUE);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  // Tbɉ0.0ɐݒitF[hAEgj
  // ʂ0.0ɂȂƁAIɍĐ~
  OggPlayer.SetVolume(0, 0.0, 5.0);
  // Đ߂𔭌ĂƃCC
  OggPlayer.Play(0,TRUE);
end;


procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  // ScrollBarCxgbNĂ炳Ȃ
  if (FScrollBarLock)then exit;
  // OnIdelCxgbN
  FOnIdleLock := TRUE;
  // V[N
  OggPlayer.TimeSeek(0,ScrollBar1.Position);
  // ܂V[NR}hÂ킢̂ŁA҂
  Sleep(50);
  // OnIdelCxg̃bN
  FOnIdleLock := FALSE;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  // Đ
  OggPlayer.SetVolume(0,1.0);
  OggPlayer.Play(0,TRUE);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  // ~
  OggPlayer.Stop(0);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  // Oggt@CI
  if (Opendialog1.Execute = FALSE)then exit;
  Load(1,Opendialog1.FileName);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  // Đ
  OggPlayer.SetVolume(1,1.0);  
  OggPlayer.Play(1,TRUE);
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  // ~
  OggPlayer.Stop(1);
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  // Tbɉ1.0ɐݒitF[hCłȁj
  OggPlayer.SetVolume(1, 1.0, 5.0);
  // Đ߂𔭌ĂƃCC
  OggPlayer.Play(1,TRUE);
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  // Tbɉ0.0ɐݒitF[hAEgj
  // ʂ0.0ɂȂƁAIɍĐ~
  OggPlayer.SetVolume(1, 0.0, 5.0);
  // Đ߂𔭌ĂƃCC
  OggPlayer.Play(1,TRUE);
end;

procedure TForm1.ScrollBar2Change(Sender: TObject);
begin
  // ScrollBarCxgbNĂ炳Ȃ
  if (FScrollBarLock)then exit;
  // OnIdleCxg̃bN
  FOnIdleLock := TRUE;
  // V[N
  OggPlayer.TimeSeek(1,ScrollBar2.Position);
  // ܂V[NR}hÂ킢̂ŁA҂
  Sleep(150);
  // OnIdleCxg̃bN
  FOnIdleLock := FALSE;
end;

procedure TForm1.ScrollBar3Change(Sender: TObject);
begin
  //`l̃}X^[{[ݒiɂ̓tF[h̊TO͂Ȃj
  OggPlayer.SetChannelVolume(0,ScrollBar3.Position/100);
end;

procedure TForm1.ScrollBar4Change(Sender: TObject);
begin
  //`l̃}X^[{[ݒiɂ̓tF[h̊TO͂Ȃj
  OggPlayer.SetChannelVolume(1,ScrollBar4.Position/100);
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
  //S`lĐ
  OggPlayer.SetVolume(0,1.0);
  OggPlayer.SetVolume(1,1.0);
  OggPlayer.Play(TRUE);
end;

procedure TForm1.Button12Click(Sender: TObject);
begin
  //S`l~
  OggPlayer.Stop;
end;

procedure TForm1.ScrollBar5Change(Sender: TObject);
begin
  //S`l̃{[ݒ
  OggPlayer.SetMasterVolume(ScrollBar5.Position/100);
end;

procedure TForm1.IdleEvent(sender: TObject; var done: Boolean);
var
  i : Integer;
  x1,x2 : Integer;
begin
  // FOnIdlebNĂꍇ͔
  if (FOnIdleLock)then exit;

  // ScrollBarCxgbN
  FScrollBarLock := TRUE;

  //ݍĐ̌oߎԂԂ
  Edit1.Text := format('%.2f sec',[OggPlayer.GetOutputTime(0)]);
  Edit2.Text := format('%.2f sec',[OggPlayer.GetOutputTime(1)]);

  // vOXo[ɃA^CLeftARight̉ʂ𔽉f
  ProgressBar1.Position := Round(OggPlayer.GetMasterOutputSum(0)*100);
  ProgressBar2.Position := Round(OggPlayer.GetMasterOutputSum(1)*100);

  // ݂̍ĐԂ\EV[No[ɔf
  ScrollBar1.Position := Round(OggPlayer.TimeTell(0));
  ScrollBar2.Position := Round(OggPlayer.TimeTell(1));

  //EQ&Graph\
  OggPlayer.GetoutputGraph(0,@graph1);
  with Image2.Canvas do
  begin
    Brush.Color := $02000000;
    FillRect(rect(0,0,64,48));
    //EQ
    for i:=0 to 61 do
    begin
      Brush.Color := $02FF00BB + i*$400;
      FillRect(rect(i+1,48,i+2,48-Round(OggPlayer.GetNowEQ(0,i*4)*24)));
    end;
    //Graph
    Brush.Color := $02FF00FF;
    for i:=0 to 61 do
      FillRect(rect(i+1,48,i+2,48-Round(graph1[i*4]*48)));
  end;

  OggPlayer.GetoutputGraph(1,@graph2);
  with Image3.Canvas do
  begin
    Brush.Color := $02000000;
    FillRect(rect(0,0,64,48));
    //EQ
    for i:=0 to 61 do
    begin
      Brush.Color := $02FF00BB + i*$400;
      FillRect(rect(i+1,48,i+2,48-Round(OggPlayer.GetNowEQ(1,i*4)*24)));
    end;
    //Graph
    Brush.Color := $02FF00FF;
    for i:=0 to 61 do
      FillRect(rect(i+1,48,i+2,48-Round(graph2[i*4]*48)));
  end;

  //MasterGraph\
  OggPlayer.GetMasterOutputGraph(@graph3);
  with Image1.Canvas do
  begin
    Brush.Color := $02000000;
    FillRect(rect(0,0,256,64));
    for i:=1 to 7 do
    begin
      Brush.Color := $02FF00BB + i*$100*32;
      FillRect(rect(i*32,0,i*32+1,48));
    end;
    for i:=0 to 253 do        //g`\
    begin
      Brush.Color := $02FF00FF + i*$100;
      FillRect(rect(i+1,48,i+2,48-Round(graph3[i]*48)));
    end;
  end;

  //͈
  with Image4.Canvas do
  begin
    Brush.Color := $02000000;
    FillRect(Image4.ClientRect);
    x1 := Round(OggPlayer.HDRMinVolume/32767*128);
    x2 := Round(OggPlayer.HDRMaxVolume/32767*128);
    Brush.Color := $02FF0000;
    FillRect(rect(x1,0,x2+1,16));
    x1 := 128;
    Brush.Color := $020000FF;
    FillRect(rect(x1,0,x1+1,16));
    x1 := Round(OggPlayer.HDRVolume/32767*128);
    Brush.Color := $02FFFFFF;
    FillRect(rect(x1,0,x1+1,16));
  end;
  with OggPlayer do
    ListenerLabel.Caption := format(
      'pos(%d) down.%d delay.%d',
      [HDRVolume,HDRDownVolume,HDRDelaySample]
    );

  // ScrollBarCxgbN
  FScrollBarLock := FALSE;

  //点
  Sleep(15);
  
  Done := FALSE;
end;

procedure TForm1.Button13Click(Sender: TObject);
begin
  // LowPass
  OggPlayer.SetEQ4(0, 1,0,0,0, 5.0);
end;

procedure TForm1.Button14Click(Sender: TObject);
begin
  // HighPass
  OggPlayer.SetEQ4(0, 0,0,1,0, 5.0);
end;

procedure TForm1.Button15Click(Sender: TObject);
begin
  // LowReso
  OggPlayer.SetEQ4(0, 2,1,1,1, 5.0);
end;

procedure TForm1.Button16Click(Sender: TObject);
begin
  // HighReso
  OggPlayer.SetEQ4(0, 1,1,2,1, 5.0);
end;

procedure TForm1.Button17Click(Sender: TObject);
begin
  // Normal
  OggPlayer.SetEQ4(0, 1,1,1,1, 5.0);
end;

procedure TForm1.Button19Click(Sender: TObject);
begin
  // MiddleReso
  OggPlayer.SetEQ4(0, 1,2,1,1, 5.0);
end;

procedure TForm1.Button20Click(Sender: TObject);
begin
  // Wave
  OggPlayer.SetEQ8(0, 1.5,0.5,1.5,0.5,1.5,0.5,1.5,0.5, 5.0);    //݂ɂ
end;

procedure TForm1.Button18Click(Sender: TObject);
begin
  // LowHigh Pass
  OggPlayer.SetEQ4(0, 1.0,0.0,1.0,0.0, 5.0);
end;

procedure TForm1.Button21Click(Sender: TObject);
begin
  // LowPass
  OggPlayer.SetEQ4(1, 1,0,0,0, 5.0);
end;

procedure TForm1.Button22Click(Sender: TObject);
begin
  // HighPass
  OggPlayer.SetEQ4(1, 0,0,1,0, 5.0);
end;

procedure TForm1.Button26Click(Sender: TObject);
begin
  // LowHigh Pass
  OggPlayer.SetEQ4(1, 1.0,0.0,1.0,0.0, 5.0);
end;

procedure TForm1.Button25Click(Sender: TObject);
begin
  // Normal
  OggPlayer.SetEQ4(1, 1,1,1,1, 5.0);
end;

procedure TForm1.Button23Click(Sender: TObject);
begin
  // LowReso
  OggPlayer.SetEQ4(1, 2,1,1,1, 5.0);
end;

procedure TForm1.Button24Click(Sender: TObject);
begin
  // HighReso
  OggPlayer.SetEQ4(1, 1,1,2,1, 5.0);
end;

procedure TForm1.Button27Click(Sender: TObject);
begin
  // MiddleReso
  OggPlayer.SetEQ4(1, 1,2,1,1, 5.0);
end;

procedure TForm1.Button28Click(Sender: TObject);
begin
  // Wave
  OggPlayer.SetEQ8(1, 1.5,0.5,1.5,0.5,1.5,0.5,1.5,0.5, 5.0);    //݂ɂ
end;

procedure TForm1.Button29Click(Sender: TObject);
begin
  OggPlayer.Pause(0);
end;

procedure TForm1.Button30Click(Sender: TObject);
begin
  OggPlayer.Pause(1);
end;



procedure TForm1.ScrollBar6Change(Sender: TObject);
begin
  if (OggPlayer.OggData[0]<>nil)then
    OggPlayer.OggData[0].SetAGC(ScrollBar6.Position/10);   //0...OFF
end;

procedure TForm1.ScrollBar7Change(Sender: TObject);
begin
  if (OggPlayer.OggData[1]<>nil)then
    OggPlayer.OggData[1].SetAGC(ScrollBar7.Position/10);   //0...OFF
end;

procedure TForm1.DropFiles(var Msg: TWMDROPFILES);
var
  nFiles: integer;
  pszBuf: array [0..255] of Char;
  i: integer;
  strFile: string;
  sl : TStringList;
begin
  sl := TStringList.Create;

  if Msg.Drop > 0 then
  begin
    // 2=-1($FFFFFFFF) --> hbvꂽt@C̐Ԃ
    nFiles := DragQueryFile(Msg.Drop, $FFFFFFFF, pszBuf, 255);

    for i:=0 to nFiles-1 do
    begin
    	// iԖڂ̃t@C𓾂
    	DragQueryFile(Msg.Drop, i, pszBuf, 255);
    	strFile := StrPas(pszBuf);
    	sl.Add(strFile);
    end;
    // n
    DragFinish(Msg.Drop);
  end;

  for i:=0 to sl.Count-1 do
  begin
    if (i<2)then
      Load(i,sl.Strings[i]);
  end;

end;

procedure TForm1.Load(no:Integer; filename: String);
begin
  if not(FileExists(filename))then exit;
  
  // OggDataɃt@Cǂݍ܂
  OggData[no].LoadOgg(filename);
  // OggPlayerɓo^
  OggPlayer.Load(no,OggData[no]);
  OggPlayer.Play(no,TRUE);

  //ȏĂ`
  memo1.Clear;
  Memo1.Lines.Add(OggData[no].OggVendor);
  Memo1.Lines.AddStrings(OggData[no].GetComment('COMMENT'));
  Memo1.Lines.Add('Channels:'+IntToStr(OggData[no].OggChannels));
  Memo1.Lines.Add('Rate:'+IntToStr(OggData[no].OggRate));
  Memo1.Lines.Add('TotalTime:'+FloatToStr(OggData[no].TotalTime));
  Memo1.Lines.Add('TotalSize:'+IntToStr(OggData[no].TotalSize));

  //V[No[̍őlȂ̒(Time(sec))ɐݒ
  ScrollBar1.Max := Round(OggData[no].TotalTime);
end;

procedure TForm1.MaxVolumeBarChange(Sender: TObject);
begin
  OggPlayer.SetHDRArea(
    MinVolumeBar.Position*32767 div 100,
    MaxVolumeBar.Position*32767 div 100,
    FadeVolumeBar.Position
  );
end;

procedure TForm1.WavePosFunction(var pos, len: Integer);
var
  p,r : Integer;
begin
  if (wav=nil)then
  begin
    pos := 0;
    len := 0;
    exit;
  end;
  wav.Buffer.GetCurrentPosition(@p,@r);
  pos := p;
  len := wav.Length;
end;

end.
